| Flutter Linux Embedder |

Typedefs | Enumerations | Functions
fl_engine_private.h File Reference
`#include <glib-object.h>`
`#include "flutter/shell/platform/embedder/embedder.h"`
`#include "flutter/shell/platform/linux/fl_display_monitor.h"`
`#include "flutter/shell/platform/linux/fl_keyboard_manager.h"`
`#include "flutter/shell/platform/linux/fl_mouse_cursor_handler.h"`
`#include "flutter/shell/platform/linux/fl_opengl_manager.h"`
`#include "flutter/shell/platform/linux/fl_renderable.h"`
`#include "flutter/shell/platform/linux/fl_task_runner.h"`
`#include "flutter/shell/platform/linux/fl_text_input_handler.h"`
`#include "flutter/shell/platform/linux/fl_windowing_handler.h"`
`#include "flutter/shell/platform/linux/public/flutter_linux/fl_dart_project.h"`
`#include "flutter/shell/platform/linux/public/flutter_linux/fl_engine.h"`

Go to the source code of this file.

## Typedefs
typedef gboolean(* | FlEnginePlatformMessageHandler) (FlEngine *engine, const gchar *channel, GBytes *message, const FlutterPlatformMessageResponseHandle *response_handle, gpointer user_data)

## Enumerations
enum | FlEngineError { FL_ENGINE_ERROR_FAILED }

## Functions
GQuark | fl_engine_error_quark (void) G_GNUC_CONST
FlEngine * | fl_engine_new_with_binary_messenger (FlBinaryMessenger *binary_messenger)
FlutterRendererType | fl_engine_get_renderer_type (FlEngine *engine)
FlOpenGLManager * | fl_engine_get_opengl_manager (FlEngine *engine)
FlDisplayMonitor * | fl_engine_get_display_monitor (FlEngine *engine)
gboolean | fl_engine_start (FlEngine *engine, GError **error)
FlutterEngineProcTable * | fl_engine_get_embedder_api (FlEngine *engine)
void | fl_engine_notify_display_update (FlEngine *engine, const FlutterEngineDisplay *displays, size_t displays_length)
void | fl_engine_set_implicit_view (FlEngine *engine, FlRenderable *renderable)
FlutterViewId | fl_engine_add_view (FlEngine *engine, FlRenderable *renderable, size_t width, size_t height, double pixel_ratio, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer user_data)
gboolean | fl_engine_add_view_finish (FlEngine *engine, GAsyncResult *result, GError **error)
FlRenderable * | fl_engine_get_renderable (FlEngine *engine, FlutterViewId view_id)
void | fl_engine_remove_view (FlEngine *engine, FlutterViewId view_id, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer user_data)
gboolean | fl_engine_remove_view_finish (FlEngine *engine, GAsyncResult *result, GError **error)
void | fl_engine_set_platform_message_handler (FlEngine *engine, FlEnginePlatformMessageHandler handler, gpointer user_data, GDestroyNotify destroy_notify)
void | fl_engine_send_window_metrics_event (FlEngine *engine, FlutterEngineDisplayId display_id, FlutterViewId view_id, size_t width, size_t height, double pixel_ratio)
void | fl_engine_send_mouse_pointer_event (FlEngine *engine, FlutterViewId view_id, FlutterPointerPhase phase, size_t timestamp, double x, double y, FlutterPointerDeviceKind device_kind, double scroll_delta_x, double scroll_delta_y, int64_t buttons)
void | fl_engine_send_touch_up_event (FlEngine *engine, FlutterViewId view_id, size_t timestamp, double x, double y, int32_t device)
void | fl_engine_send_touch_down_event (FlEngine *engine, FlutterViewId view_id, size_t timestamp, double x, double y, int32_t device)
void | fl_engine_send_touch_move_event (FlEngine *engine, FlutterViewId view_id, size_t timestamp, double x, double y, int32_t device)
void | fl_engine_send_touch_add_event (FlEngine *engine, FlutterViewId view_id, size_t timestamp, double x, double y, int32_t device)
void | fl_engine_send_touch_remove_event (FlEngine *engine, FlutterViewId view_id, size_t timestamp, double x, double y, int32_t device)
void | fl_engine_send_pointer_pan_zoom_event (FlEngine *engine, FlutterViewId view_id, size_t timestamp, double x, double y, FlutterPointerPhase phase, double pan_x, double pan_y, double scale, double rotation)
void | fl_engine_send_key_event (FlEngine *engine, const FlutterKeyEvent *event, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer user_data)
gboolean | fl_engine_send_key_event_finish (FlEngine *engine, GAsyncResult *result, gboolean *handled, GError **error)
void | fl_engine_dispatch_semantics_action (FlEngine *engine, FlutterViewId view_id, uint64_t node_id, FlutterSemanticsAction action, GBytes *data)
gboolean | fl_engine_send_platform_message_response (FlEngine *engine, const FlutterPlatformMessageResponseHandle *handle, GBytes *response, GError **error)
void | fl_engine_send_platform_message (FlEngine *engine, const gchar *channel, GBytes *message, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer user_data)
GBytes * | fl_engine_send_platform_message_finish (FlEngine *engine, GAsyncResult *result, GError **error)
FlTaskRunner * | fl_engine_get_task_runner (FlEngine *engine)
void | fl_engine_execute_task (FlEngine *engine, FlutterTask *task)
gboolean | fl_engine_mark_texture_frame_available (FlEngine *engine, int64_t texture_id)
gboolean | fl_engine_register_external_texture (FlEngine *engine, int64_t texture_id)
gboolean | fl_engine_unregister_external_texture (FlEngine *engine, int64_t texture_id)
void | fl_engine_update_accessibility_features (FlEngine *engine, int32_t flags)
void | fl_engine_request_app_exit (FlEngine *engine)
FlWindowingHandler * | fl_engine_get_windowing_handler (FlEngine *engine)
FlKeyboardManager * | fl_engine_get_keyboard_manager (FlEngine *engine)
FlTextInputHandler * | fl_engine_get_text_input_handler (FlEngine *engine)
FlMouseCursorHandler * | fl_engine_get_mouse_cursor_handler (FlEngine *engine)
FlEngine * | fl_engine_for_id (int64_t handle)

## Typedef Documentation

## ◆ FlEnginePlatformMessageHandler

typedef gboolean(* FlEnginePlatformMessageHandler) (FlEngine *engine, const gchar *channel, GBytes *message, const FlutterPlatformMessageResponseHandle *response_handle, gpointer user_data)

FlEnginePlatformMessageHandler: @engine: an #FlEngine. @channel: channel message received on. @message: message content received from Dart. @response_handle: a handle to respond to the message with. @user_data: (closure): data provided when registering this handler.

Function called when platform messages are received.

Returns: TRUE if message has been accepted.

Definition at line 47 of file fl_engine_private.h.

## Enumeration Type Documentation

## ◆ FlEngineError

enum FlEngineError

FlEngineError: Errors for #FlEngine objects to set on failures.

Enumerator
FL_ENGINE_ERROR_FAILED |

Definition at line 29 of file fl_engine_private.h.

29 {
30 FL_ENGINE_ERROR_FAILED,
31 } FlEngineError;
FlEngineError
FlEngineError
Definition: fl_engine_private.h:29
FL_ENGINE_ERROR_FAILED
@ FL_ENGINE_ERROR_FAILED
Definition: fl_engine_private.h:30

## Function Documentation

## ◆ fl_engine_add_view()

FlutterViewId fl_engine_add_view | ( | FlEngine * | engine,
|  | FlRenderable * | renderable,
|  | size_t | width,
|  | size_t | height,
|  | double | pixel_ratio,
|  | GCancellable * | cancellable,
|  | GAsyncReadyCallback | callback,
|  | gpointer | user_data
| ) |  |

fl_engine_add_view: @engine: an #FlEngine. @renderable: the object that will render this view. @width: width of view in pixels. @height: height of view in pixels. @pixel_ratio: scale factor for view. @cancellable: (allow-none): a #GCancellable or NULL. @callback: (scope async): a #GAsyncReadyCallback to call when the view is added. @user_data: (closure): user data to pass to @callback.

Asynchronously add a new view. The returned view ID should not be used until this function completes.

Returns: the ID for the view.

Definition at line 883 of file fl_engine.cc.

890 {
891 g_return_val_if_fail(FL_IS_ENGINE(self), -1);
892
893 g_autoptr(GTask) task = g_task_new(self, cancellable, callback, user_data);
894
895 FlutterViewId view_id = self->next_view_id;
896 self->next_view_id++;
897
898 GWeakRef* ref = g_new(GWeakRef, 1);
899 g_weak_ref_init(ref, G_OBJECT(renderable));
900 g_hash_table_insert(self->renderables_by_view_id, GINT_TO_POINTER(view_id),
901 ref);
902
903 // We don't know which display this view will open on, so set to zero and this
904 // will be updated in a following FlutterWindowMetricsEvent
905 FlutterEngineDisplayId display_id = 0;
906
907 FlutterWindowMetricsEvent metrics = {};
908 metrics.struct_size = sizeof(FlutterWindowMetricsEvent);
909 metrics.width = width;
910 metrics.height = height;
911 metrics.pixel_ratio = pixel_ratio;
912 metrics.display_id = display_id;
913 metrics.view_id = view_id;
914 FlutterAddViewInfo info;
915 info.struct_size = sizeof(FlutterAddViewInfo);
916 info.view_id = view_id;
917 info.view_metrics = &metrics;
918 info.user_data = g_object_ref(task);
919 info.add_view_callback = view_added_cb;
920 FlutterEngineResult result = self->embedder_api.AddView(self->engine, &info);
921 if (result != kSuccess) {
922 g_task_return_new_error(task, fl_engine_error_quark(),
923 FL_ENGINE_ERROR_FAILED, "AddView returned %d",
924 result);
925 // This would have been done in the callback, but that won't occur now.
926 g_object_unref(task);
927 }
928
929 return view_id;
930 }
height
self height
Definition: fl_compositor_software.cc:43
g_autoptr
g_autoptr(GMutexLocker) locker
width
self width
Definition: fl_compositor_software.cc:42
self
g_cond_signal & self
Definition: fl_compositor_software.cc:67
view_added_cb
static void view_added_cb(const FlutterAddViewResult *result)
Definition: fl_engine.cc:171
fl_engine_error_quark
GQuark fl_engine_error_quark(void) G_GNUC_CONST
user_data
G_BEGIN_DECLS G_MODULE_EXPORT FlValue gpointer user_data
Definition: fl_event_channel.h:90
view_id
G_BEGIN_DECLS FlutterViewId view_id
Definition: fl_view_accessible.h:49

References FL_ENGINE_ERROR_FAILED, fl_engine_error_quark(), g_autoptr(), height, self, user_data, view_added_cb(), view_id, and width.

Referenced by fl_view_new_for_engine(), and TEST().

## ◆ fl_engine_add_view_finish()

gboolean fl_engine_add_view_finish | ( | FlEngine * | engine,
|  | GAsyncResult * | result,
|  | GError ** | error
| ) |  |

fl_engine_add_view_finish: @engine: an #FlEngine.

Returns
  : a #GAsyncResult. @error: (allow-none): #GError location to store the error occurring, or NULL to ignore.

Completes request started with fl_engine_add_view().

Returns: TRUE on success.

Definition at line 932 of file fl_engine.cc.

934 {
935 g_return_val_if_fail(FL_IS_ENGINE(self), FALSE);
936 return g_task_propagate_boolean(G_TASK(result), error);
937 }
error
const uint8_t uint32_t uint32_t GError ** error
Definition: fl_pixel_buffer_texture_test.cc:40

References error.

Referenced by add_view_cb(), add_view_engine_error_cb(), add_view_error_cb(), and view_added_cb().

## ◆ fl_engine_dispatch_semantics_action()

void fl_engine_dispatch_semantics_action | ( | FlEngine * | engine,
|  | FlutterViewId | view_id,
|  | uint64_t | node_id,
|  | FlutterSemanticsAction | action,
|  | GBytes * | data
| ) |  |

fl_engine_dispatch_semantics_action: @engine: an #FlEngine. @view_id: the view that the event occured on. @node_id: the semantics action identifier. @action: the action being dispatched. @data: (allow-none): data associated with the action.

Definition at line 1365 of file fl_engine.cc.

1369 {
1370 g_return_if_fail(FL_IS_ENGINE(self));
1371
1372 if (self->engine == nullptr) {
1373 return;
1374 }
1375
1376 const uint8_t* action_data = nullptr;
1377 size_t action_data_length = 0;
1378 if (data != nullptr) {
1379 action_data = static_cast<const uint8_t*>(
1380 g_bytes_get_data(data, &action_data_length));
1381 }
1382
1383 FlutterSendSemanticsActionInfo info;
1384 info.struct_size = sizeof(FlutterSendSemanticsActionInfo);
1385 info.view_id = view_id;
1386 info.node_id = node_id;
1387 info.action = action;
1388 info.data = action_data;
1389 info.data_length = action_data_length;
1390 self->embedder_api.SendSemanticsAction(self->engine, &info);
1391 }
action
FlutterSemanticsAction action
Definition: fl_accessible_node.cc:86

References action, self, and view_id.

Referenced by fl_accessible_node_perform_action_impl(), and TEST().

## ◆ fl_engine_error_quark()

GQuark fl_engine_error_quark | ( | void |  | ) |

Referenced by fl_engine_add_view(), fl_engine_remove_view(), fl_engine_send_key_event(), fl_engine_send_platform_message(), fl_engine_send_platform_message_response(), fl_engine_start(), view_added_cb(), and view_removed_cb().

## ◆ fl_engine_execute_task()

void fl_engine_execute_task | ( | FlEngine * | engine,
|  | FlutterTask * | task
| ) |  |

fl_engine_execute_task: @engine: an #FlEngine. @task: a #FlutterTask to execute.

Executes given Flutter task.

Definition at line 1425 of file fl_engine.cc.

1425 {
1426 g_return_if_fail(FL_IS_ENGINE(self));
1427 self->embedder_api.RunTask(self->engine, task);
1428 }

References self.

Referenced by fl_task_runner_process_expired_tasks_locked().

## ◆ fl_engine_for_id()

FlEngine* fl_engine_for_id | ( | int64_t | handle | ) |

fl_engine_for_id: @handle: an engine identifier obtained through PlatformDispatcher.instance.engineId.

Returns Flutter engine associated with the identifier. The identifier must be valid and for a running engine otherwise the behavior is undefined. Must be called from the main thread.

Returns: a #FlEngine or NULL.

Definition at line 686 of file fl_engine.cc.

686 {
687 void* engine = reinterpret_cast<void*>(id);
688 g_return_val_if_fail(FL_IS_ENGINE(engine), nullptr);
689 return FL_ENGINE(engine);
690 }
id
int64_t id
Definition: fl_pixel_buffer_texture.cc:28

References id.

Referenced by TEST().

## ◆ fl_engine_get_display_monitor()

FlDisplayMonitor* fl_engine_get_display_monitor | ( | FlEngine * | engine | ) |

fl_engine_get_display_monitor: @engine: an #FlEngine.

Gets the display monitor used by this engine.

Returns: an #FlDisplayMonitor.

Definition at line 716 of file fl_engine.cc.

716 {
717 g_return_val_if_fail(FL_IS_ENGINE(self), nullptr);
718 return self->display_monitor;
719 }

Referenced by handle_geometry_changed(), and TEST().

## ◆ fl_engine_get_embedder_api()

FlutterEngineProcTable* fl_engine_get_embedder_api | ( | FlEngine * | engine | ) |

fl_engine_get_embedder_api: @engine: an #FlEngine.

Gets the embedder API proc table, allowing modificiations for unit testing.

Returns: a mutable pointer to the embedder API proc table.

Definition at line 859 of file fl_engine.cc.

859 {
860 return &(self->embedder_api);
861 }

Referenced by TEST().

## ◆ fl_engine_get_keyboard_manager()

FlKeyboardManager* fl_engine_get_keyboard_manager | ( | FlEngine * | engine | ) |

fl_engine_get_keyboard_manager: @engine: an #FlEngine.

Gets the keyboard manager used by this engine.

Returns: an #FlKeyboardManager.

Definition at line 1457 of file fl_engine.cc.

1457 {
1458 g_return_val_if_fail(FL_IS_ENGINE(self), nullptr);
1459 return self->keyboard_manager;
1460 }

Referenced by handle_key_event(), sync_modifier_if_needed(), and TEST().

## ◆ fl_engine_get_mouse_cursor_handler()

FlMouseCursorHandler* fl_engine_get_mouse_cursor_handler | ( | FlEngine * | engine | ) |

fl_engine_get_mouse_cursor_handler: @engine: an #FlEngine.

Gets the mouse cursor handler used by this engine.

Returns: an #FlMouseCursorHandler.

Definition at line 1467 of file fl_engine.cc.

1467 {
1468 g_return_val_if_fail(FL_IS_ENGINE(self), nullptr);
1469 return self->mouse_cursor_handler;
1470 }

Referenced by cursor_changed_cb(), fl_view_dispose(), setup_cursor(), and TEST().

## ◆ fl_engine_get_opengl_manager()

FlOpenGLManager* fl_engine_get_opengl_manager | ( | FlEngine * | engine | ) |

fl_engine_get_opengl_manager: @engine: an #FlEngine.

Gets the OpenGL manager used by this engine.

Returns: an #FlOpenGLManager.

Definition at line 711 of file fl_engine.cc.

711 {
712 g_return_val_if_fail(FL_IS_ENGINE(self), nullptr);
713 return self->opengl_manager;
714 }

Referenced by fl_compositor_opengl_new(), and realize_cb().

## ◆ fl_engine_get_renderable()

FlRenderable* fl_engine_get_renderable | ( | FlEngine * | engine,
|  | FlutterViewId | view_id
| ) |  |

fl_engine_get_renderable: @engine: an #FlEngine. @view_id: ID to check.

Gets the renderable associated with the give view ID.

Returns: (transfer full): a reference to an #FlRenderable or NULL if none for this ID.

Definition at line 939 of file fl_engine.cc.

939 {
940 g_return_val_if_fail(FL_IS_ENGINE(self), nullptr);
941
942 GWeakRef* ref = static_cast<GWeakRef*>(g_hash_table_lookup(
943 self->renderables_by_view_id, GINT_TO_POINTER(view_id)));
944 return FL_RENDERABLE(g_weak_ref_get(ref));
945 }

References self, and view_id.

## ◆ fl_engine_get_renderer_type()

FlutterRendererType fl_engine_get_renderer_type | ( | FlEngine * | engine | ) |

fl_engine_get_renderer_type: @engine: an #FlEngine.

Gets the rendering type used by this engine.

Returns: type of rendering used.

Definition at line 706 of file fl_engine.cc.

706 {
707 g_return_val_if_fail(FL_IS_ENGINE(self), static_cast<FlutterRendererType>(0));
708 return self->renderer_type;
709 }

Referenced by realize_cb().

## ◆ fl_engine_get_task_runner()

FlTaskRunner* fl_engine_get_task_runner | ( | FlEngine * | engine | ) |

fl_engine_get_task_runner: @engine: an #FlEngine.

Returns
  : a #FlTaskRunner.

Returns: task runner responsible for scheduling Flutter tasks.

Definition at line 1420 of file fl_engine.cc.

1420 {
1421 g_return_val_if_fail(FL_IS_ENGINE(self), nullptr);
1422 return self->task_runner;
1423 }

Referenced by TEST().

## ◆ fl_engine_get_text_input_handler()

FlTextInputHandler* fl_engine_get_text_input_handler | ( | FlEngine * | engine | ) |

fl_engine_get_text_input_handler: @engine: an #FlEngine.

Gets the text input handler used by this engine.

Returns: an #FlTextInputHandler.

Definition at line 1462 of file fl_engine.cc.

1462 {
1463 g_return_val_if_fail(FL_IS_ENGINE(self), nullptr);
1464 return self->text_input_handler;
1465 }

Referenced by fl_view_focus_in_event(), and handle_key_event().

## ◆ fl_engine_get_windowing_handler()

FlWindowingHandler* fl_engine_get_windowing_handler | ( | FlEngine * | engine | ) |

fl_engine_get_windowing_handler: @engine: an #FlEngine.

Gets the windowing handler used by this engine.

Returns: an #FlWindowingHandler.

Definition at line 1452 of file fl_engine.cc.

1452 {
1453 g_return_val_if_fail(FL_IS_ENGINE(self), nullptr);
1454 return self->windowing_handler;
1455 }

Referenced by fl_application_activate(), and TEST().

## ◆ fl_engine_mark_texture_frame_available()

gboolean fl_engine_mark_texture_frame_available | ( | FlEngine * | engine,
|  | int64_t | texture_id
| ) |  |

fl_engine_mark_texture_frame_available: @engine: an #FlEngine. @texture_id: the identifier of the texture whose frame has been updated.

Tells the Flutter engine that a new texture frame is available for the given texture.

Returns: TRUE on success.

Definition at line 1393 of file fl_engine.cc.

1394 {
1395 g_return_val_if_fail(FL_IS_ENGINE(self), FALSE);
1396 return self->embedder_api.MarkExternalTextureFrameAvailable(
1397 self->engine, texture_id) == kSuccess;
1398 }
texture_id
int64_t texture_id
Definition: texture_registrar_unittests.cc:24

References self, and texture_id.

Referenced by mark_texture_frame_available().

## ◆ fl_engine_new_with_binary_messenger()

FlEngine* fl_engine_new_with_binary_messenger | ( | FlBinaryMessenger * | binary_messenger | ) |

fl_engine_new_with_binary_messenger: @binary_messenger: an #FlBinaryMessenger.

Creates a new engine with a custom binary messenger. Used for testing.

Returns: a new #FlEngine.

Definition at line 696 of file fl_engine.cc.

697 {
698 g_autoptr(FlDartProject) project = fl_dart_project_new();
699 return fl_engine_new_full(project, binary_messenger);
700 }
fl_dart_project_new
G_MODULE_EXPORT FlDartProject * fl_dart_project_new()
Definition: fl_dart_project.cc:52
fl_engine_new_full
static FlEngine * fl_engine_new_full(FlDartProject *project, FlBinaryMessenger *binary_messenger)
Definition: fl_engine.cc:649

References fl_dart_project_new(), fl_engine_new_full(), and g_autoptr().

Referenced by TEST().

## ◆ fl_engine_notify_display_update()

void fl_engine_notify_display_update | ( | FlEngine * | engine,
|  | const FlutterEngineDisplay * | displays,
|  | size_t | displays_length
| ) |  |

fl_engine_notify_display_update: @engine: an #FlEngine. @displays: displays present on the system. @displays_length: length of @displays.

Notify the current displays that are in the system.

Definition at line 863 of file fl_engine.cc.

865 {
866 g_return_if_fail(FL_IS_ENGINE(self));
867
868 FlutterEngineResult result = self->embedder_api.NotifyDisplayUpdate(
869 self->engine, kFlutterEngineDisplaysUpdateTypeStartup, displays,
870 displays_length);
871 if (result != kSuccess) {
872 g_warning("Failed to notify display update to Flutter engine: %d", result);
873 }
874 }

References self.

Referenced by notify_display_update(), and TEST().

## ◆ fl_engine_register_external_texture()

gboolean fl_engine_register_external_texture | ( | FlEngine * | engine,
|  | int64_t | texture_id
| ) |  |

fl_engine_register_external_texture: @engine: an #FlEngine. @texture_id: the identifier of the texture that is available.

Tells the Flutter engine that a new external texture is available.

Returns: TRUE on success.

Definition at line 1400 of file fl_engine.cc.

1401 {
1402 g_return_val_if_fail(FL_IS_ENGINE(self), FALSE);
1403 return self->embedder_api.RegisterExternalTexture(self->engine, texture_id) ==
1404 kSuccess;
1405 }

References self, and texture_id.

Referenced by register_texture().

## ◆ fl_engine_remove_view()

void fl_engine_remove_view | ( | FlEngine * | engine,
|  | FlutterViewId | view_id,
|  | GCancellable * | cancellable,
|  | GAsyncReadyCallback | callback,
|  | gpointer | user_data
| ) |  |

fl_engine_remove_view: @engine: an #FlEngine. @view_id: ID to remove. @cancellable: (allow-none): a #GCancellable or NULL. @callback: (scope async): a #GAsyncReadyCallback to call when the view is added. @user_data: (closure): user data to pass to @callback.

Removes a view previously added with fl_engine_add_view().

Definition at line 947 of file fl_engine.cc.

951 {
952 g_return_if_fail(FL_IS_ENGINE(self));
953
954 g_hash_table_remove(self->renderables_by_view_id, GINT_TO_POINTER(view_id));
955
956 g_autoptr(GTask) task = g_task_new(self, cancellable, callback, user_data);
957
958 FlutterRemoveViewInfo info;
959 info.struct_size = sizeof(FlutterRemoveViewInfo);
960 info.view_id = view_id;
961 info.user_data = g_object_ref(task);
962 info.remove_view_callback = view_removed_cb;
963 FlutterEngineResult result =
964 self->embedder_api.RemoveView(self->engine, &info);
965 if (result != kSuccess) {
966 g_task_return_new_error(task, fl_engine_error_quark(),
967 FL_ENGINE_ERROR_FAILED, "RemoveView returned %d",
968 result);
969 // This would have been done in the callback, but that won't occur now.
970 g_object_unref(task);
971 }
972 }
view_removed_cb
static void view_removed_cb(const FlutterRemoveViewResult *result)
Definition: fl_engine.cc:182

References FL_ENGINE_ERROR_FAILED, fl_engine_error_quark(), g_autoptr(), self, user_data, view_id, and view_removed_cb().

Referenced by fl_view_dispose(), and TEST().

## ◆ fl_engine_remove_view_finish()

gboolean fl_engine_remove_view_finish | ( | FlEngine * | engine,
|  | GAsyncResult * | result,
|  | GError ** | error
| ) |  |

fl_engine_remove_view_finish: @engine: an #FlEngine.

Returns
  : a #GAsyncResult. @error: (allow-none): #GError location to store the error occurring, or NULL to ignore.

Completes request started with fl_engine_remove_view().

Returns: TRUE on succcess.

Definition at line 974 of file fl_engine.cc.

976 {
977 g_return_val_if_fail(FL_IS_ENGINE(self), FALSE);
978 return g_task_propagate_boolean(G_TASK(result), error);
979 }

References error.

Referenced by remove_view_cb(), remove_view_engine_error_cb(), and remove_view_error_cb().

## ◆ fl_engine_request_app_exit()

void fl_engine_request_app_exit | ( | FlEngine * | engine | ) |

fl_engine_request_app_exit: @engine: an #FlEngine.

Request the application exits.

Definition at line 1447 of file fl_engine.cc.

1447 {
1448 g_return_if_fail(FL_IS_ENGINE(self));
1449 fl_platform_handler_request_app_exit(self->platform_handler);
1450 }
fl_platform_handler_request_app_exit
void fl_platform_handler_request_app_exit(FlPlatformHandler *self)
Definition: fl_platform_handler.cc:267

References fl_platform_handler_request_app_exit(), and self.

Referenced by window_delete_event_cb().

## ◆ fl_engine_send_key_event()

void fl_engine_send_key_event | ( | FlEngine * | engine,
|  | const FlutterKeyEvent * | event,
|  | GCancellable * | cancellable,
|  | GAsyncReadyCallback | callback,
|  | gpointer | user_data
| ) |  |

fl_engine_send_key_event: @engine: an #FlEngine. @event: key event to send. @cancellable: (allow-none): a #GCancellable or NULL. @callback: (scope async): a #GAsyncReadyCallback to call when the request is satisfied. @user_data: (closure): user data to pass to @callback.

Send a key event to the engine.

Definition at line 1325 of file fl_engine.cc.

1329 {
1330 g_return_if_fail(FL_IS_ENGINE(self));
1331
1332 g_autoptr(GTask) task = g_task_new(self, cancellable, callback, user_data);
1333
1334 if (self->engine == nullptr) {
1335 g_task_return_new_error(task, fl_engine_error_quark(),
1336 FL_ENGINE_ERROR_FAILED, "No engine");
1337 return;
1338 }
1339
1340 if (self->embedder_api.SendKeyEvent(self->engine, event, send_key_event_cb,
1341 g_object_ref(task)) != kSuccess) {
1342 g_task_return_new_error(task, fl_engine_error_quark(),
1343 FL_ENGINE_ERROR_FAILED, "Failed to send key event");
1344 g_object_unref(task);
1345 }
1346 }
send_key_event_cb
static void send_key_event_cb(bool handled, void *user_data)
Definition: fl_engine.cc:1318

References FL_ENGINE_ERROR_FAILED, fl_engine_error_quark(), g_autoptr(), self, send_key_event_cb(), and user_data.

Referenced by fl_key_embedder_responder_handle_event(), fl_key_embedder_responder_handle_event_impl(), synthesize_simple_event(), and TEST().

## ◆ fl_engine_send_key_event_finish()

gboolean fl_engine_send_key_event_finish | ( | FlEngine * | engine,
|  | GAsyncResult * | result,
|  | gboolean * | handled,
|  | GError ** | error
| ) |  |

fl_engine_send_key_event_finish: @engine: an #FlEngine.

Returns
  : a #GAsyncResult. @handled: location to write if this event was handled by the engine. @error: (allow-none): #GError location to store the error occurring, or NULL to ignore.

Completes request started with fl_engine_send_key_event().

Returns: TRUE on success.

Definition at line 1348 of file fl_engine.cc.

1351 {
1352 g_return_val_if_fail(FL_IS_ENGINE(self), FALSE);
1353 g_return_val_if_fail(g_task_is_valid(result, self), FALSE);
1354
1355 g_autofree gboolean* return_value =
1356 static_cast<gboolean*>(g_task_propagate_pointer(G_TASK(result), error));
1357 if (return_value == nullptr) {
1358 return FALSE;
1359 }
1360
1361 *handled = *return_value;
1362 return TRUE;
1363 }
TRUE
return TRUE
Definition: fl_compositor_software.cc:69

References error, and TRUE.

Referenced by TEST().

## ◆ fl_engine_send_mouse_pointer_event()

void fl_engine_send_mouse_pointer_event | ( | FlEngine * | engine,
|  | FlutterViewId | view_id,
|  | FlutterPointerPhase | phase,
|  | size_t | timestamp,
|  | double | x,
|  | double | y,
|  | FlutterPointerDeviceKind | device_kind,
|  | double | scroll_delta_x,
|  | double | scroll_delta_y,
|  | int64_t | buttons
| ) |  |

fl_engine_send_mouse_pointer_event: @engine: an #FlEngine. @view_id: the view that the event occured on. @phase: mouse phase. @timestamp: time when event occurred in microseconds. @x: x location of mouse cursor. @y: y location of mouse cursor. @device_kind: kind of pointing device. @scroll_delta_x: x offset of scroll. @scroll_delta_y: y offset of scroll. @buttons: buttons that are pressed.

Sends a mouse pointer event to the engine.

Definition at line 1122 of file fl_engine.cc.

1131 {
1132 g_return_if_fail(FL_IS_ENGINE(self));
1133
1134 if (self->engine == nullptr) {
1135 return;
1136 }
1137
1138 FlutterPointerEvent fl_event = {};
1139 fl_event.struct_size = sizeof(fl_event);
1140 fl_event.phase = phase;
1141 fl_event.timestamp = timestamp;
1142 fl_event.x = x;
1143 fl_event.y = y;
1144 if (scroll_delta_x != 0 || scroll_delta_y != 0) {
1145 fl_event.signal_kind = kFlutterPointerSignalKindScroll;
1146 }
1147 fl_event.scroll_delta_x = scroll_delta_x;
1148 fl_event.scroll_delta_y = scroll_delta_y;
1149 fl_event.device_kind = device_kind;
1150 fl_event.buttons = buttons;
1151 fl_event.device = kMousePointerDeviceId;
1152 fl_event.view_id = view_id;
1153 self->embedder_api.SendPointerEvent(self->engine, &fl_event, 1);
1154 }
kMousePointerDeviceId
static constexpr int32_t kMousePointerDeviceId
Definition: fl_engine.cc:36

References kMousePointerDeviceId, self, and view_id.

Referenced by ensure_pointer_added(), fl_pointer_manager_handle_button_press(), fl_pointer_manager_handle_button_release(), fl_pointer_manager_handle_leave(), fl_pointer_manager_handle_motion(), fl_scrolling_manager_handle_scroll_event(), and TEST().

## ◆ fl_engine_send_platform_message()

void fl_engine_send_platform_message | ( | FlEngine * | engine,
|  | const gchar * | channel,
|  | GBytes * | message,
|  | GCancellable * | cancellable,
|  | GAsyncReadyCallback | callback,
|  | gpointer | user_data
| ) |  |

fl_engine_send_platform_message: @engine: an #FlEngine. @channel: channel to send to. @message: (allow-none): message buffer to send or NULL for an empty message @cancellable: (allow-none): a #GCancellable or NULL. @callback: (scope async): a #GAsyncReadyCallback to call when the request is satisfied. @user_data: (closure): user data to pass to @callback.

Asynchronously sends a platform message.

Definition at line 1032 of file fl_engine.cc.

1037 {
1038 g_return_if_fail(FL_IS_ENGINE(self));
1039
1040 GTask* task = nullptr;
1041 FlutterPlatformMessageResponseHandle* response_handle = nullptr;
1042 if (callback != nullptr) {
1043 task = g_task_new(self, cancellable, callback, user_data);
1044
1045 if (self->engine == nullptr) {
1046 g_task_return_new_error(task, fl_engine_error_quark(),
1047 FL_ENGINE_ERROR_FAILED, "No engine to send to");
1048 return;
1049 }
1050
1051 FlutterEngineResult result =
1052 self->embedder_api.PlatformMessageCreateResponseHandle(
1053 self->engine, fl_engine_platform_message_response_cb, task,
1054 &response_handle);
1055 if (result != kSuccess) {
1056 g_task_return_new_error(task, fl_engine_error_quark(),
1057 FL_ENGINE_ERROR_FAILED,
1058 "Failed to create response handle");
1059 g_object_unref(task);
1060 return;
1061 }
1062 } else if (self->engine == nullptr) {
1063 return;
1064 }
1065
1066 FlutterPlatformMessage fl_message = {};
1067 fl_message.struct_size = sizeof(fl_message);
1068 fl_message.channel = channel;
1069 fl_message.message =
1070 message != nullptr
1071 ? static_cast<const uint8_t*>(g_bytes_get_data(message, nullptr))
1072 : nullptr;
1073 fl_message.message_size = message != nullptr ? g_bytes_get_size(message) : 0;
1074 fl_message.response_handle = response_handle;
1075 FlutterEngineResult result =
1076 self->embedder_api.SendPlatformMessage(self->engine, &fl_message);
1077
1078 if (result != kSuccess && task != nullptr) {
1079 g_task_return_new_error(task, fl_engine_error_quark(),
1080 FL_ENGINE_ERROR_FAILED,
1081 "Failed to send platform messages");
1082 g_object_unref(task);
1083 }
1084
1085 if (response_handle != nullptr) {
1086 self->embedder_api.PlatformMessageReleaseResponseHandle(self->engine,
1087 response_handle);
1088 }
1089 }
fl_engine_platform_message_response_cb
static void fl_engine_platform_message_response_cb(const uint8_t *data, size_t data_length, void *user_data)
Definition: fl_engine.cc:523

References FL_ENGINE_ERROR_FAILED, fl_engine_error_quark(), fl_engine_platform_message_response_cb(), self, and user_data.

Referenced by send_on_channel(), and TEST().

## ◆ fl_engine_send_platform_message_finish()

GBytes* fl_engine_send_platform_message_finish | ( | FlEngine * | engine,
|  | GAsyncResult * | result,
|  | GError ** | error
| ) |  |

fl_engine_send_platform_message_finish: @engine: an #FlEngine.

Returns
  : a #GAsyncResult. @error: (allow-none): #GError location to store the error occurring, or NULL to ignore.

Completes request started with fl_engine_send_platform_message().

Returns: message response on success or NULL on error.

Definition at line 1091 of file fl_engine.cc.

1093 {
1094 g_return_val_if_fail(FL_IS_ENGINE(self), FALSE);
1095 g_return_val_if_fail(g_task_is_valid(result, self), FALSE);
1096
1097 return static_cast<GBytes*>(g_task_propagate_pointer(G_TASK(result), error));
1098 }

References error.

Referenced by send_on_channel_finish().

## ◆ fl_engine_send_platform_message_response()

gboolean fl_engine_send_platform_message_response | ( | FlEngine * | engine,
|  | const FlutterPlatformMessageResponseHandle * | handle,
|  | GBytes * | response,
|  | GError ** | error
| ) |  |

fl_engine_send_platform_message_response: @engine: an #FlEngine. @handle: handle that was provided in FlEnginePlatformMessageHandler. @response: (allow-none): response to send or NULL for an empty response. @error: (allow-none): #GError location to store the error occurring, or NULL to ignore.

Responds to a platform message.

Returns: TRUE on success.

Definition at line 1000 of file fl_engine.cc.

1004 {
1005 g_return_val_if_fail(FL_IS_ENGINE(self), FALSE);
1006 g_return_val_if_fail(handle != nullptr, FALSE);
1007
1008 if (self->engine == nullptr) {
1009 g_set_error(error, fl_engine_error_quark(), FL_ENGINE_ERROR_FAILED,
1010 "No engine to send response to");
1011 return FALSE;
1012 }
1013
1014 gsize data_length = 0;
1015 const uint8_t* data = nullptr;
1016 if (response != nullptr) {
1017 data =
1018 static_cast<const uint8_t*>(g_bytes_get_data(response, &data_length));
1019 }
1020 FlutterEngineResult result = self->embedder_api.SendPlatformMessageResponse(
1021 self->engine, handle, data, data_length);
1022
1023 if (result != kSuccess) {
1024 g_set_error(error, fl_engine_error_quark(), FL_ENGINE_ERROR_FAILED,
1025 "Failed to send platform message response");
1026 return FALSE;
1027 }
1028
1029 return TRUE;
1030 }

References error, FL_ENGINE_ERROR_FAILED, fl_engine_error_quark(), self, and TRUE.

Referenced by fl_engine_platform_message_cb(), send_response(), and TEST().

## ◆ fl_engine_send_pointer_pan_zoom_event()

void fl_engine_send_pointer_pan_zoom_event | ( | FlEngine * | engine,
|  | FlutterViewId | view_id,
|  | size_t | timestamp,
|  | double | x,
|  | double | y,
|  | FlutterPointerPhase | phase,
|  | double | pan_x,
|  | double | pan_y,
|  | double | scale,
|  | double | rotation
| ) |  |

fl_engine_send_pointer_pan_zoom_event: @engine: an #FlEngine. @view_id: the view that the event occured on. @timestamp: time when event occurred in microseconds. @x: x location of mouse cursor. @y: y location of mouse cursor. @phase: mouse phase. @pan_x: x offset of the pan/zoom in pixels. @pan_y: y offset of the pan/zoom in pixels. @scale: scale of the pan/zoom. @rotation: rotation of the pan/zoom in radians.

Sends a pan/zoom pointer event to the engine.

Definition at line 1286 of file fl_engine.cc.

1295 {
1296 g_return_if_fail(FL_IS_ENGINE(self));
1297
1298 if (self->engine == nullptr) {
1299 return;
1300 }
1301
1302 FlutterPointerEvent fl_event = {};
1303 fl_event.struct_size = sizeof(fl_event);
1304 fl_event.timestamp = timestamp;
1305 fl_event.x = x;
1306 fl_event.y = y;
1307 fl_event.phase = phase;
1308 fl_event.pan_x = pan_x;
1309 fl_event.pan_y = pan_y;
1310 fl_event.scale = scale;
1311 fl_event.rotation = rotation;
1312 fl_event.device = kPointerPanZoomDeviceId;
1313 fl_event.device_kind = kFlutterPointerDeviceKindTrackpad;
1314 fl_event.view_id = view_id;
1315 self->embedder_api.SendPointerEvent(self->engine, &fl_event, 1);
1316 }
kPointerPanZoomDeviceId
static constexpr int32_t kPointerPanZoomDeviceId
Definition: fl_engine.cc:37

References kPointerPanZoomDeviceId, self, and view_id.

Referenced by fl_scrolling_manager_handle_rotation_begin(), fl_scrolling_manager_handle_rotation_end(), fl_scrolling_manager_handle_rotation_update(), fl_scrolling_manager_handle_scroll_event(), fl_scrolling_manager_handle_zoom_begin(), fl_scrolling_manager_handle_zoom_end(), fl_scrolling_manager_handle_zoom_update(), and TEST().

## ◆ fl_engine_send_touch_add_event()

void fl_engine_send_touch_add_event | ( | FlEngine * | engine,
|  | FlutterViewId | view_id,
|  | size_t | timestamp,
|  | double | x,
|  | double | y,
|  | int32_t | device
| ) |  |

fl_engine_send_touch_add_event: @engine: an #FlEngine. @view_id: the view that the event occured on. @timestamp: time when event occurred in microseconds. @x: x location of mouse cursor. @y: y location of mouse cursor. @device: device id.

Sends a touch add event to the engine.

Definition at line 1234 of file fl_engine.cc.

1239 {
1240 g_return_if_fail(FL_IS_ENGINE(self));
1241
1242 if (self->engine == nullptr) {
1243 return;
1244 }
1245
1246 FlutterPointerEvent event;
1247 event.timestamp = timestamp;
1248 event.x = x;
1249 event.y = y;
1250 event.device_kind = kFlutterPointerDeviceKindTouch;
1251 event.device = device;
1252 event.buttons = 0;
1253 event.view_id = view_id;
1254 event.phase = FlutterPointerPhase::kAdd;
1255 event.struct_size = sizeof(event);
1256
1257 self->embedder_api.SendPointerEvent(self->engine, &event, 1);
1258 }

References self, and view_id.

Referenced by ensure_touch_added().

## ◆ fl_engine_send_touch_down_event()

void fl_engine_send_touch_down_event | ( | FlEngine * | engine,
|  | FlutterViewId | view_id,
|  | size_t | timestamp,
|  | double | x,
|  | double | y,
|  | int32_t | device
| ) |  |

fl_engine_send_touch_down_event: @engine: an #FlEngine. @view_id: the view that the event occured on. @timestamp: time when event occurred in microseconds. @x: x location of mouse cursor. @y: y location of mouse cursor. @device: device id.

Sends a touch down event to the engine.

Definition at line 1182 of file fl_engine.cc.

1187 {
1188 g_return_if_fail(FL_IS_ENGINE(self));
1189
1190 if (self->engine == nullptr) {
1191 return;
1192 }
1193
1194 FlutterPointerEvent event;
1195 event.timestamp = timestamp;
1196 event.x = x;
1197 event.y = y;
1198 event.device_kind = kFlutterPointerDeviceKindTouch;
1199 event.device = device;
1200 event.buttons = FlutterPointerMouseButtons::kFlutterPointerButtonMousePrimary;
1201 event.view_id = view_id;
1202 event.phase = FlutterPointerPhase::kDown;
1203 event.struct_size = sizeof(event);
1204
1205 self->embedder_api.SendPointerEvent(self->engine, &event, 1);
1206 }

References self, and view_id.

Referenced by fl_touch_manager_handle_touch_event().

## ◆ fl_engine_send_touch_move_event()

void fl_engine_send_touch_move_event | ( | FlEngine * | engine,
|  | FlutterViewId | view_id,
|  | size_t | timestamp,
|  | double | x,
|  | double | y,
|  | int32_t | device
| ) |  |

fl_engine_send_touch_move_event: @engine: an #FlEngine. @view_id: the view that the event occured on. @timestamp: time when event occurred in microseconds. @x: x location of mouse cursor. @y: y location of mouse cursor. @device: device id.

Sends a touch move event to the engine.

Definition at line 1208 of file fl_engine.cc.

1213 {
1214 g_return_if_fail(FL_IS_ENGINE(self));
1215
1216 if (self->engine == nullptr) {
1217 return;
1218 }
1219
1220 FlutterPointerEvent event;
1221 event.timestamp = timestamp;
1222 event.x = x;
1223 event.y = y;
1224 event.device_kind = kFlutterPointerDeviceKindTouch;
1225 event.device = device;
1226 event.buttons = FlutterPointerMouseButtons::kFlutterPointerButtonMousePrimary;
1227 event.view_id = view_id;
1228 event.phase = FlutterPointerPhase::kMove;
1229 event.struct_size = sizeof(event);
1230
1231 self->embedder_api.SendPointerEvent(self->engine, &event, 1);
1232 }

References self, and view_id.

Referenced by fl_touch_manager_handle_touch_event().

## ◆ fl_engine_send_touch_remove_event()

void fl_engine_send_touch_remove_event | ( | FlEngine * | engine,
|  | FlutterViewId | view_id,
|  | size_t | timestamp,
|  | double | x,
|  | double | y,
|  | int32_t | device
| ) |  |

fl_engine_send_touch_remove_event: @engine: an #FlEngine. @view_id: the view that the event occured on. @timestamp: time when event occurred in microseconds. @x: x location of mouse cursor. @y: y location of mouse cursor. @device: device id.

Sends a touch remove event to the engine.

Definition at line 1260 of file fl_engine.cc.

1265 {
1266 g_return_if_fail(FL_IS_ENGINE(self));
1267
1268 if (self->engine == nullptr) {
1269 return;
1270 }
1271
1272 FlutterPointerEvent event;
1273 event.timestamp = timestamp;
1274 event.x = x;
1275 event.y = y;
1276 event.device_kind = kFlutterPointerDeviceKindTouch;
1277 event.device = device;
1278 event.buttons = 0;
1279 event.view_id = view_id;
1280 event.phase = FlutterPointerPhase::kRemove;
1281 event.struct_size = sizeof(event);
1282
1283 self->embedder_api.SendPointerEvent(self->engine, &event, 1);
1284 }

References self, and view_id.

Referenced by fl_touch_manager_handle_touch_event().

## ◆ fl_engine_send_touch_up_event()

void fl_engine_send_touch_up_event | ( | FlEngine * | engine,
|  | FlutterViewId | view_id,
|  | size_t | timestamp,
|  | double | x,
|  | double | y,
|  | int32_t | device
| ) |  |

fl_engine_send_touch_up_event: @engine: an #FlEngine. @view_id: the view that the event occured on. @timestamp: time when event occurred in microseconds. @x: x location of mouse cursor. @y: y location of mouse cursor. @device: device id.

Sends a touch up event to the engine.

Definition at line 1156 of file fl_engine.cc.

1161 {
1162 g_return_if_fail(FL_IS_ENGINE(self));
1163
1164 if (self->engine == nullptr) {
1165 return;
1166 }
1167
1168 FlutterPointerEvent event;
1169 event.timestamp = timestamp;
1170 event.x = x;
1171 event.y = y;
1172 event.device_kind = kFlutterPointerDeviceKindTouch;
1173 event.device = device;
1174 event.buttons = 0;
1175 event.view_id = view_id;
1176 event.phase = FlutterPointerPhase::kUp;
1177 event.struct_size = sizeof(event);
1178
1179 self->embedder_api.SendPointerEvent(self->engine, &event, 1);
1180 }

References self, and view_id.

Referenced by fl_touch_manager_handle_touch_event().

## ◆ fl_engine_send_window_metrics_event()

void fl_engine_send_window_metrics_event | ( | FlEngine * | engine,
|  | FlutterEngineDisplayId | display_id,
|  | FlutterViewId | view_id,
|  | size_t | width,
|  | size_t | height,
|  | double | pixel_ratio
| ) |  |

fl_engine_send_window_metrics_event: @engine: an #FlEngine. @display_id: the display this view is rendering on. @view_id: the view that the event occured on. @width: width of the window in pixels. @height: height of the window in pixels. @pixel_ratio: scale factor for window.

Sends a window metrics event to the engine.

Definition at line 1100 of file fl_engine.cc.

1105 {
1106 g_return_if_fail(FL_IS_ENGINE(self));
1107
1108 if (self->engine == nullptr) {
1109 return;
1110 }
1111
1112 FlutterWindowMetricsEvent event = {};
1113 event.struct_size = sizeof(FlutterWindowMetricsEvent);
1114 event.width = width;
1115 event.height = height;
1116 event.pixel_ratio = pixel_ratio;
1117 event.display_id = display_id;
1118 event.view_id = view_id;
1119 self->embedder_api.SendWindowMetricsEvent(self->engine, &event);
1120 }

References height, self, view_id, and width.

Referenced by handle_geometry_changed(), and TEST().

## ◆ fl_engine_set_implicit_view()

void fl_engine_set_implicit_view | ( | FlEngine * | engine,
|  | FlRenderable * | renderable
| ) |  |

fl_engine_set_implicit_view: @engine: an #FlEngine. @renderable: the object that will render the implicit view.

Sets the object to render the implicit view.

Definition at line 876 of file fl_engine.cc.

876 {
877 GWeakRef* ref = g_new(GWeakRef, 1);
878 g_weak_ref_init(ref, G_OBJECT(renderable));
879 g_hash_table_insert(self->renderables_by_view_id,
880 GINT_TO_POINTER(flutter::kFlutterImplicitViewId), ref);
881 }

References self.

Referenced by fl_view_new(), and TEST().

## ◆ fl_engine_set_platform_message_handler()

void fl_engine_set_platform_message_handler | ( | FlEngine * | engine,
|  | FlEnginePlatformMessageHandler | handler,
|  | gpointer | user_data,
|  | GDestroyNotify | destroy_notify
| ) |  |

fl_engine_set_platform_message_handler: @engine: an #FlEngine. @handler: function to call when a platform message is received. @user_data: (closure): user data to pass to @handler. @destroy_notify: (allow-none): a function which gets called to free @user_data, or NULL.

Registers the function called when a platform message is received. Call fl_engine_send_platform_message_response() with the response to this message. Ownership of #FlutterPlatformMessageResponseHandle is transferred to the caller, and the message must be responded to avoid memory leaks.

Definition at line 981 of file fl_engine.cc.

985 {
986 g_return_if_fail(FL_IS_ENGINE(self));
987 g_return_if_fail(handler != nullptr);
988
989 if (self->platform_message_handler_destroy_notify) {
990 self->platform_message_handler_destroy_notify(
991 self->platform_message_handler_data);
992 }
993
994 self->platform_message_handler = handler;
995 self->platform_message_handler_data = user_data;
996 self->platform_message_handler_destroy_notify = destroy_notify;
997 }

References self, and user_data.

Referenced by fl_binary_messenger_new().

## ◆ fl_engine_start()

gboolean fl_engine_start | ( | FlEngine * | engine,
|  | GError ** | error
| ) |  |

fl_engine_start: @engine: an #FlEngine. @error: (allow-none): #GError location to store the error occurring, or NULL to ignore.

Starts the Flutter engine.

Returns: TRUE on success.

Definition at line 721 of file fl_engine.cc.

721 {
722 g_return_val_if_fail(FL_IS_ENGINE(self), FALSE);
723
724 FlutterRendererConfig config = {};
725 config.type = self->renderer_type;
726 switch (config.type) {
727 case kSoftware:
728 config.software.struct_size = sizeof(FlutterSoftwareRendererConfig);
729 // No action required, as this is handled in
730 // compositor_present_view_callback.
731 config.software.surface_present_callback =
732 [](void* user_data, const void* allocation, size_t row_bytes,
733 size_t height) { return true; };
734 break;
735 case kOpenGL:
736 config.open_gl.struct_size = sizeof(FlutterOpenGLRendererConfig);
737 config.open_gl.gl_proc_resolver = fl_engine_gl_proc_resolver;
738 config.open_gl.make_current = fl_engine_gl_make_current;
739 config.open_gl.clear_current = fl_engine_gl_clear_current;
740 config.open_gl.fbo_callback = fl_engine_gl_get_fbo;
741 // No action required, as this is handled in
742 // compositor_present_view_callback.
743 config.open_gl.present = [](void* user_data) { return true; };
744 config.open_gl.make_resource_current = fl_engine_gl_make_resource_current;
745 config.open_gl.gl_external_texture_frame_callback =
746 fl_engine_gl_external_texture_frame_callback;
747 break;
748 case kMetal:
749 case kVulkan:
750 default:
751 g_set_error(error, fl_engine_error_quark(), FL_ENGINE_ERROR_FAILED,
752 "Unsupported renderer type");
753 return FALSE;
754 }
755
756 FlutterTaskRunnerDescription platform_task_runner = {};
757 platform_task_runner.struct_size = sizeof(FlutterTaskRunnerDescription);
758 platform_task_runner.user_data = self;
759 platform_task_runner.runs_task_on_current_thread_callback =
760 fl_engine_runs_task_on_current_thread;
761 platform_task_runner.post_task_callback = fl_engine_post_task;
762 platform_task_runner.identifier = kPlatformTaskRunnerIdentifier;
763
764 FlutterCustomTaskRunners custom_task_runners = {};
765 custom_task_runners.struct_size = sizeof(FlutterCustomTaskRunners);
766 custom_task_runners.platform_task_runner = &platform_task_runner;
767
768 if (fl_dart_project_get_ui_thread_policy(self->project) ==
769 FL_UI_THREAD_POLICY_RUN_ON_PLATFORM_THREAD) {
770 custom_task_runners.ui_task_runner = &platform_task_runner;
771 }
772
773 g_autoptr(GPtrArray) command_line_args =
774 g_ptr_array_new_with_free_func(g_free);
775 g_ptr_array_insert(command_line_args, 0, g_strdup("flutter"));
776 for (const auto& env_switch : flutter::GetSwitchesFromEnvironment()) {
777 g_ptr_array_add(command_line_args, g_strdup(env_switch.c_str()));
778 }
779
780 gchar** dart_entrypoint_args =
781 fl_dart_project_get_dart_entrypoint_arguments(self->project);
782
783 FlutterProjectArgs args = {};
784 args.struct_size = sizeof(FlutterProjectArgs);
785 args.assets_path = fl_dart_project_get_assets_path(self->project);
786 args.icu_data_path = fl_dart_project_get_icu_data_path(self->project);
787 args.command_line_argc = command_line_args->len;
788 args.command_line_argv =
789 reinterpret_cast<const char* const*>(command_line_args->pdata);
790 args.platform_message_callback = fl_engine_platform_message_cb;
791 args.update_semantics_callback2 = fl_engine_update_semantics_cb;
792 args.custom_task_runners = &custom_task_runners;
793 args.shutdown_dart_vm_when_done = true;
794 args.on_pre_engine_restart_callback = fl_engine_on_pre_engine_restart_cb;
795 args.dart_entrypoint_argc =
796 dart_entrypoint_args != nullptr ? g_strv_length(dart_entrypoint_args) : 0;
797 args.dart_entrypoint_argv =
798 reinterpret_cast<const char* const*>(dart_entrypoint_args);
799 args.engine_id = reinterpret_cast<int64_t>(self);
800
801 FlutterCompositor compositor = {};
802 compositor.struct_size = sizeof(FlutterCompositor);
803 compositor.user_data = self;
804 compositor.create_backing_store_callback =
805 compositor_create_backing_store_callback;
806 compositor.collect_backing_store_callback =
807 compositor_collect_backing_store_callback;
808 compositor.present_view_callback = compositor_present_view_callback;
809 args.compositor = &compositor;
810
811 if (self->embedder_api.RunsAOTCompiledDartCode()) {
812 FlutterEngineAOTDataSource source = {};
813 source.type = kFlutterEngineAOTDataSourceTypeElfPath;
814 source.elf_path = fl_dart_project_get_aot_library_path(self->project);
815 if (self->embedder_api.CreateAOTData(&source, &self->aot_data) !=
816 kSuccess) {
817 g_set_error(error, fl_engine_error_quark(), FL_ENGINE_ERROR_FAILED,
818 "Failed to create AOT data");
819 return FALSE;
820 }
821 args.aot_data = self->aot_data;
822 }
823
824 FlutterEngineResult result = self->embedder_api.Initialize(
825 FLUTTER_ENGINE_VERSION, &config, &args, self, &self->engine);
826 if (result != kSuccess) {
827 g_set_error(error, fl_engine_error_quark(), FL_ENGINE_ERROR_FAILED,
828 "Failed to initialize Flutter engine");
829 return FALSE;
830 }
831
832 result = self->embedder_api.RunInitialized(self->engine);
833 if (result != kSuccess) {
834 g_set_error(error, fl_engine_error_quark(), FL_ENGINE_ERROR_FAILED,
835 "Failed to run Flutter engine");
836 return FALSE;
837 }
838
839 setup_locales(self);
840
841 g_autoptr(FlSettings) settings = fl_settings_new();
842 self->settings_handler = fl_settings_handler_new(self);
843 fl_settings_handler_start(self->settings_handler, settings);
844
845 self->platform_handler = fl_platform_handler_new(self->binary_messenger);
846
847 setup_keyboard(self);
848
849 result = self->embedder_api.UpdateSemanticsEnabled(self->engine, TRUE);
850 if (result != kSuccess) {
851 g_warning("Failed to enable accessibility features on Flutter engine");
852 }
853
854 fl_display_monitor_start(self->display_monitor);
855
856 return TRUE;
857 }
fl_dart_project_get_aot_library_path
G_MODULE_EXPORT const gchar * fl_dart_project_get_aot_library_path(FlDartProject *self)
Definition: fl_dart_project.cc:74
fl_dart_project_get_dart_entrypoint_arguments
G_MODULE_EXPORT gchar ** fl_dart_project_get_dart_entrypoint_arguments(FlDartProject *self)
Definition: fl_dart_project.cc:106
fl_dart_project_get_icu_data_path
G_MODULE_EXPORT const gchar * fl_dart_project_get_icu_data_path(FlDartProject *self)
Definition: fl_dart_project.cc:100
fl_dart_project_get_assets_path
G_MODULE_EXPORT const gchar * fl_dart_project_get_assets_path(FlDartProject *self)
Definition: fl_dart_project.cc:87
fl_dart_project_get_ui_thread_policy
G_MODULE_EXPORT FlUIThreadPolicy fl_dart_project_get_ui_thread_policy(FlDartProject *project)
Definition: fl_dart_project.cc:128
FL_UI_THREAD_POLICY_RUN_ON_PLATFORM_THREAD
@ FL_UI_THREAD_POLICY_RUN_ON_PLATFORM_THREAD
Definition: fl_dart_project.h:143
fl_display_monitor_start
void fl_display_monitor_start(FlDisplayMonitor *self)
Definition: fl_display_monitor.cc:103
fl_engine_gl_external_texture_frame_callback
static bool fl_engine_gl_external_texture_frame_callback(void *user_data, int64_t texture_id, size_t width, size_t height, FlutterOpenGLTexture *opengl_texture)
Definition: fl_engine.cc:406
fl_engine_runs_task_on_current_thread
static bool fl_engine_runs_task_on_current_thread(void *user_data)
Definition: fl_engine.cc:447
fl_engine_on_pre_engine_restart_cb
static void fl_engine_on_pre_engine_restart_cb(void *user_data)
Definition: fl_engine.cc:513
compositor_create_backing_store_callback
static bool compositor_create_backing_store_callback(const FlutterBackingStoreConfig *config, FlutterBackingStore *backing_store_out, void *user_data)
Definition: fl_engine.cc:327
fl_engine_gl_make_current
static bool fl_engine_gl_make_current(void *user_data)
Definition: fl_engine.cc:382
compositor_present_view_callback
static bool compositor_present_view_callback(const FlutterPresentViewInfo *info)
Definition: fl_engine.cc:358
compositor_collect_backing_store_callback
static bool compositor_collect_backing_store_callback(const FlutterBackingStore *backing_store, void *user_data)
Definition: fl_engine.cc:343
fl_engine_post_task
static void fl_engine_post_task(FlutterTask task, uint64_t target_time_nanos, void *user_data)
Definition: fl_engine.cc:453
fl_engine_gl_get_fbo
static uint32_t fl_engine_gl_get_fbo(void *user_data)
Definition: fl_engine.cc:394
fl_engine_gl_proc_resolver
static void * fl_engine_gl_proc_resolver(void *user_data, const char *name)
Definition: fl_engine.cc:378
setup_keyboard
static void setup_keyboard(FlEngine *self)
Definition: fl_engine.cc:489
setup_locales
static void setup_locales(FlEngine *self)
Definition: fl_engine.cc:200
fl_engine_update_semantics_cb
static void fl_engine_update_semantics_cb(const FlutterSemanticsUpdate2 *update, void *user_data)
Definition: fl_engine.cc:482
fl_engine_gl_make_resource_current
static bool fl_engine_gl_make_resource_current(void *user_data)
Definition: fl_engine.cc:399
fl_engine_platform_message_cb
static void fl_engine_platform_message_cb(const FlutterPlatformMessage *message, void *user_data)
Definition: fl_engine.cc:462
kPlatformTaskRunnerIdentifier
static constexpr size_t kPlatformTaskRunnerIdentifier
Definition: fl_engine.cc:32
fl_engine_gl_clear_current
static bool fl_engine_gl_clear_current(void *user_data)
Definition: fl_engine.cc:388
args
G_BEGIN_DECLS G_MODULE_EXPORT FlValue * args
Definition: fl_event_channel.h:89
fl_platform_handler_new
FlPlatformHandler * fl_platform_handler_new(FlBinaryMessenger *messenger)
Definition: fl_platform_handler.cc:254
fl_settings_new
FlSettings * fl_settings_new()
Definition: fl_settings.cc:55
fl_settings_handler_start
void fl_settings_handler_start(FlSettingsHandler *self, FlSettings *settings)
Definition: fl_settings_handler.cc:88
fl_settings_handler_new
FlSettingsHandler * fl_settings_handler_new(FlEngine *engine)
Definition: fl_settings_handler.cc:74
flutter::GetSwitchesFromEnvironment
std::vector< std::string > GetSwitchesFromEnvironment()
Definition: engine_switches.cc:14

References args, compositor_collect_backing_store_callback(), compositor_create_backing_store_callback(), compositor_present_view_callback(), error, fl_dart_project_get_aot_library_path(), fl_dart_project_get_assets_path(), fl_dart_project_get_dart_entrypoint_arguments(), fl_dart_project_get_icu_data_path(), fl_dart_project_get_ui_thread_policy(), fl_display_monitor_start(), FL_ENGINE_ERROR_FAILED, fl_engine_error_quark(), fl_engine_gl_clear_current(), fl_engine_gl_external_texture_frame_callback(), fl_engine_gl_get_fbo(), fl_engine_gl_make_current(), fl_engine_gl_make_resource_current(), fl_engine_gl_proc_resolver(), fl_engine_on_pre_engine_restart_cb(), fl_engine_platform_message_cb(), fl_engine_post_task(), fl_engine_runs_task_on_current_thread(), fl_engine_update_semantics_cb(), fl_platform_handler_new(), fl_settings_handler_new(), fl_settings_handler_start(), fl_settings_new(), FL_UI_THREAD_POLICY_RUN_ON_PLATFORM_THREAD, g_autoptr(), flutter::GetSwitchesFromEnvironment(), height, kPlatformTaskRunnerIdentifier, self, setup_keyboard(), setup_locales(), TRUE, and user_data.

Referenced by realize_cb(), and TEST().

## ◆ fl_engine_unregister_external_texture()

gboolean fl_engine_unregister_external_texture | ( | FlEngine * | engine,
|  | int64_t | texture_id
| ) |  |

fl_engine_unregister_external_texture: @engine: an #FlEngine. @texture_id: the identifier of the texture that is not available anymore.

Tells the Flutter engine that an existing external texture is not available anymore.

Returns: TRUE on success.

Definition at line 1407 of file fl_engine.cc.

1408 {
1409 g_return_val_if_fail(FL_IS_ENGINE(self), FALSE);
1410 return self->embedder_api.UnregisterExternalTexture(self->engine,
1411 texture_id) == kSuccess;
1412 }

References self, and texture_id.

Referenced by unregister_texture().

## ◆ fl_engine_update_accessibility_features()

void fl_engine_update_accessibility_features | ( | FlEngine * | engine,
|  | int32_t | flags
| ) |  |

fl_engine_update_accessibility_features: @engine: an #FlEngine. @flags: the features to enable in the accessibility tree.

Tells the Flutter engine to update the flags on the accessibility tree.

Definition at line 1436 of file fl_engine.cc.

1436 {
1437 g_return_if_fail(FL_IS_ENGINE(self));
1438
1439 if (self->engine == nullptr) {
1440 return;
1441 }
1442
1443 self->embedder_api.UpdateAccessibilityFeatures(
1444 self->engine, static_cast<FlutterAccessibilityFeature>(flags));
1445 }

References self.

Referenced by update_settings().